<template>
  <user-dashboard-container page-class="post agent-requests-details" panel-title="فرم درخواست قطعه داغی">
    <el-alert v-if="oldPieceRequest.status === 'temp'" :title="alertMsg" class="mb-3" type="warning"> </el-alert>
    <form class="form form_3">
      <div class="userInfo">
        <div class="formRow">
          <label for="customer_name">نام و نام خانوادگی:</label>
          <input id="customer_name" type="text" :value="oldPieceRequest.agent_id.full_name" disabled />
        </div>
        <div class="formRow">
          <label for="customer_code">کد نمایندگی:</label>
          <input id="customer_code" type="text" :value="oldPieceRequest.agent_id.agent_code" disabled />
        </div>
        <div class="formRow">
          <label for="mobile">شماره موبایل:</label>
          <input id="mobile" type="text" :value="oldPieceRequest.agent_id.mobile_number" disabled />
        </div>
        <div class="formRow">
          <label for="fax">شماره فکس:</label>
          <input id="fax" type="text" :value="oldPieceRequest.agent_id.fax_number" disabled />
        </div>
        <div class="formRow">
          <label for="province">استان:</label>
          <input id="province" type="text" :value="oldPieceRequest.agent_id.province_name" disabled />
        </div>
        <div class="formRow">
          <label for="city">شهر:</label>
          <input id="city" type="text" :value="oldPieceRequest.agent_id.city_name" disabled />
        </div>
      </div>

      <div class="formRow">
        <label>آدرس:</label>
        <textarea name="description" cols="30" rows="5" disabled :value="oldPieceRequest.agent_id.address"></textarea>
      </div>

      <hr />

      <div class="formRow">
        <label v-if="oldPieceRequest.status === 'temp'" for="description">توضیحات فرم (اختیاری):</label>
        <label v-else for="description">توضیحات فرم:</label>
        <el-tooltip
          v-model="descriptionTooltip"
          class="item"
          effect="dark"
          content="میتوانید توضیحات را در هر زمان تغییر دهید"
          placement="top-start"
          :disabled="oldPieceRequest.status !== 'temp'"
        >
          <textarea
            id="description"
            v-model="oldPieceRequest.description"
            name="description"
            :disabled="oldPieceRequest.status !== 'temp'"
            :placeholder="descriptionPlaceHolder"
            cols="30"
            rows="10"
            @blur="updateDescription"
          ></textarea>
        </el-tooltip>
      </div>
    </form>

    <div class="add-list">
      <h2>لیست قطعات درخواستی:</h2>
      <div class="tableBox">
        <table class="pieces-items">
          <thead>
            <tr>
              <th class="index">ردیف</th>
              <th class="recieptDate">تاریخ پذیرش</th>
              <th class="itemName">نام کالا</th>
              <th class="itemSerial">سریال گارانتی</th>
              <th class="pieceName">نام قطعه</th>
              <th class="pieceCode">کد قطعه</th>
              <th v-if="oldPieceRequest.status === 'temp'" class="removeBtn">حذف</th>
            </tr>
          </thead>

          <tbody>
            <tr
              v-for="(item, index) in oldPieceRequest.items"
              :key="item.ItemID + index + '_opr_oldPieces'"
              :title="item.ItemName + ' - ' + item.pieceName"
            >
              <td class="index">
                <span>{{ index + 1 }}</span>
              </td>

              <td class="recieptDate">
                <span> {{ $jDate(item.ItemReceptionTransDate) }} </span>
              </td>

              <td class="itemName">
                <span class="singleLineTxt">{{ item.ItemName }}</span>
              </td>

              <td class="itemSerial">
                <span>{{ item.SerialNo1 || '-' }}</span>
              </td>

              <td class="pieceName">
                <span> {{ item.pieceName }} </span>
              </td>

              <td class="pieceCode">
                <span> {{ item.pieceCode }} </span>
              </td>

              <td v-if="oldPieceRequest.status === 'temp'" class="removeBtn">
                <button class="trashIcon-btn" title="حذف پیشنویس" @click="removeItemFromList(item._id)">
                  <i class="fal fa-trash-alt"></i>
                </button>
              </td>
            </tr>

            <tr v-if="!oldPieceRequest.items.length" class="odd">
              <td class="noItem" colspan="5">
                <p style="color: #000">هنوز هیچ آیتمی اضافه نکردید.</p>
              </td>
            </tr>

            <tr v-if="oldPieceRequest.status === 'temp'" class="addStuffBtn" @click="oldPiecesModal = true">
              <td colspan="5">
                <button>
                  <span>افزودن قطعه</span>
                  <i class="far fa-plus"></i>
                </button>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
      <table-notice />

      <hr />

      <div v-if="oldPieceRequest.status === 'temp'" class="btnRow">
        <button class="btn btn-primary" @click="sendForm">ارسال به آسان سرویس</button>
        <button class="btn btn-danger" @click="removeOPR">حذف این فرم</button>
      </div>
    </div>

    <template #body>
      <AddOldPiecesToOldPieceRequest
        :key="oldPiecesModalKey"
        :show="oldPiecesModal"
        :opr-id="oldPieceRequest._id"
        @closeModal="closePiecesModal"
      />
    </template>
  </user-dashboard-container>
</template>

<script>
export default {
  name: 'AccountAgentOpsDetails',
  layout: 'user',
  async asyncData({ $axios, params, error }) {
    try {
      const oldPieceRequest = await $axios.get(`/api/agent/opr/${params.op}`)
      return {
        oldPieceRequest: oldPieceRequest.data
      }
    } catch (e) {
      error({ status: 404, message: 'There is a problem here' })
    }
  },
  data() {
    return {
      oldPieceRequest: null,
      validation: {},
      oldPiecesModal: false,
      oldPiecesModalKey: 0,
      descriptionTooltip: false,
      alertMsg:
        'این درخواست در پیشنویس ها ذخیره شده و هنوز  در پایگاه داده شرکت آسان سرویس ثبت نگردیده. شما میتوانید قطعات را در هر زمان به این فرم اضافه یا از فرم حذف کنید سپس نسبت به ارسال نهایی اقدام کنید.'
    }
  },
  computed: {
    oprId() {
      return this.$route.params.op
    },
    descriptionPlaceHolder() {
      if (this.oldPieceRequest.status === 'temp') return 'توضیحات راجع به قطعات داغی را میتوانید اینجا بنویسید'
      else return 'بدون توضیحات'
    }
  },
  mounted() {
    setTimeout(() => {
      if (this.oldPieceRequest.status === 'temp') this.descriptionTooltip = true
    }, 1000)
  },
  methods: {
    closePiecesModal() {
      this.oldPiecesModal = false
      this.oldPiecesModalKey = Math.random()
    },
    removeItemFromList(id) {
      if (this.oldPieceRequest.status !== 'temp') return
      this.$confirm('این مورد حذف شود؟', 'هشدار', {
        confirmButtonText: 'بله',
        cancelButtonText: 'لغو',
        type: 'warning'
      })
        .then(() => {
          this.$axios
            .delete(`/api/agent/removeOprItems/${id}`)
            .then(res => {
              this.$message({
                type: 'success',
                message: res.data.message
              })
              this.$nuxt.refresh()
            })
            .catch(() => {
              this.$message({
                type: 'error',
                message: 'مشکلی در انجام عملیات پیش آمده'
              })
            })
        })
        .catch(() => {
          this.$message({
            type: 'warning',
            message: 'عملیات لغو شد'
          })
        })
    },
    updateDescription() {
      if (this.oldPieceRequest.status !== 'temp') return
      const data = { description: this.oldPieceRequest.description }
      this.$axios
        .put(`/api/agent/oprDescription/${this.oprId}`, data)
        .then(res => {
          this.$message({
            type: 'success',
            message: res.data.message
          })
        })
        .catch(() => {
          this.$message({
            type: 'error',
            message: 'مشکلی در ثبت اطلاعات پیش آمده'
          })
        })
    },
    sendForm() {
      this.$confirm('فرم درخواست قطعه داغی به آسان سرویس ارسال شود؟', 'هشدار', {
        confirmButtonText: 'بله',
        cancelButtonText: 'لغو',
        type: 'warning'
      })
        .then(() => {
          this.$axios
            .post(`/api/agent/sendOpr/${this.oprId}`)
            .then(res => {
              this.$message({
                type: 'success',
                message: res.data.message
              })
              this.$router.push({ name: 'account-agents-ops', query: { type: 'sent' } })
            })
            .catch(err => {
              let msg = 'مشکلی در ارسال درخواست پیش آمده'
              if (err.response.status === 406) msg = err.response.data.message
              this.$message({
                type: 'error',
                message: msg
              })
            })
        })
        .catch(() => {
          this.$message({
            type: 'warning',
            message: 'عملیات لغو شد'
          })
        })
    },
    removeOPR() {
      this.$confirm('این فرم از پیشنویس ها حذف شود؟', 'هشدار', {
        confirmButtonText: 'بله',
        cancelButtonText: 'لغو',
        type: 'warning'
      })
        .then(() => {
          this.$axios
            .delete(`/api/agent/opr/${this.oprId}`)
            .then(res => {
              this.$message({
                type: 'success',
                message: res.data.message
              })
              this.$router.push({ name: 'account-agents-ops', query: { type: 'temp' } })
            })
            .catch(() => {
              this.$message({
                type: 'error',
                message: 'مشکلی در حذف پیشنویس پیش آمده'
              })
            })
        })
        .catch(() => {
          this.$message({
            type: 'warning',
            message: 'عملیات لغو شد'
          })
        })
    }
  }
}
</script>
